#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include <fstream.h>
#include <dos.h>
#include <ctype.h>

void TestScoreSave()
{
	ifstream fin("HighScr.sav");
	if (!fin)
	{
		ofstream fout("HighScr.sav");
		fout << oct << -32768;
		fout.close();
	}
	fin.close();
}

void Help()
{
	clrscr();
	cout << "Target Practice Help\n";
	cout << "--------------------------------\n\n";
	cout << "The object of this game is to shoot as many targets ";
	cout << "as you can in 60 seconds.\n\n";
	cout << "Press the up arrow to move your gun up.\n";
	cout << "Press the down arrow to move your gun down.\n";
	cout << "Press space to shoot.\n";
	cout << "Press the b button to use your laser sight.\n\n";
	cout << "Each time you hit the target your score goes up ";
	cout << "by one point.\n";
	cout << "Each time you miss the target your score goes down ";
	cout << "by one point.\n\n";
	cout << "Press Any Key to Start the Game.";
	gotoxy(1,23);
	cout << "Matt Schraeder - October 2000\n";
	cout << "frozen_solid_16@hotmail.com";
	getch();
}

short StartGame()
{
	char Key;
	textbackground(LIGHTGRAY);
	textcolor(BLACK);
	clrscr();
	short HighScore;
	_setcursortype(_NOCURSOR);
	TestScoreSave();
	ifstream fin("HighScr.sav");
	fin >> oct >> HighScore;
	fin.close();
	cout << "Target Practice: Programmed by Matt Schraeder\n";
	cout << "High Score: " << HighScore;
	cout << "\n\n\nPress H for Help\nPress Any Other Key to Start";
	Key=getch();
	if (Key=='h' || Key=='H')
		Help();
	clrscr();
	return HighScore;
}

short TargetChooser()
{
	short TargetPosition = random(23)+1;
	gotoxy(80,TargetPosition);
	textcolor(RED);
	cprintf("0");
	return TargetPosition;
}

void GunShot(short GunPosition)
{
	short Loop;
	for(Loop = 5; Loop < 80; Loop++)
	{
		gotoxy(Loop,GunPosition);
		cout << "-";
		delay(2);
	}
	for(Loop = 5; Loop < 80; Loop++)
	{
		gotoxy(Loop,GunPosition);
		cout << " ";
		delay(2);
	}
}

void Explosion(short GunPosition)
{
	GunShot(GunPosition);
	gotoxy(80,GunPosition);
	textcolor(YELLOW);
	cprintf("*");
	delay(200);
	gotoxy(80,GunPosition);
	cout << " ";
}

short Scorer(short Score, short GunPosition, short TargetPosition)
{
	if(GunPosition != TargetPosition)
		Score--;
	else
		Score++;
	gotoxy(1,24);
	cout << "               ";  //Erases Old Score
	gotoxy(1,24);
	textcolor(BLUE);
	cprintf("Score: ");
	cout << Score;
	return Score;
}

void Timer(time_t TimeNow, time_t TimeStart)
{
	time_t TimeLeft = 60 - (TimeNow - TimeStart);
	gotoxy(20,24);
	textcolor(BLUE);
	cprintf("Time Left: ");
	cout << TimeLeft;
	if(TimeLeft < 10) //Erases the zero from when TimeLeft was 10
	{
		gotoxy(32,24);
		cout << " ";
	}
}

void DisplaySight(short GunPosition, short TargetPosition)
{
	gotoxy(80,GunPosition);
	textcolor(RED);
	cprintf("+");
	delay(300);
	gotoxy(80,GunPosition);
	if (GunPosition==TargetPosition)
		cprintf("0");
	else
		cout << " ";
}

void DisplayGun(short GunPosition)
{
	char Gun[] = {201, 205, 209, 196, '\0'};
	gotoxy(1,GunPosition);
	textcolor(BROWN);
	cprintf(Gun);
}

void EraseGun(short OldGunPosition)
{
	gotoxy(1,OldGunPosition);
	cout << "     ";
}

void EndGame(short FinalScore, short HighScore)
{
	textbackground(LIGHTGRAY);
	textcolor(BLACK);
	clrscr();
	if (FinalScore > HighScore)
	{
		ofstream fout("HighScr.sav");
		fout << oct << FinalScore;
		fout.close();
		cout << "CONGRATULATIONS!!!! You Got A New High Score!!!\n";
	}
	cout << "Game Over!!\nYour Final Score is: " << FinalScore;
}

short PlayAgain()
{
	char YesNo;
	do
	{
		gotoxy(1,5);
		cout << "\n\nDo You want to Play Again? (y/n): ";
		YesNo=getche();
		delay(300);
		YesNo = toupper(YesNo);
	} while (YesNo != 'Y' && YesNo != 'N');
	return YesNo == 'Y';
}

void ThankYou()
{
	textbackground(BLACK);
	textcolor(LIGHTRED);
	clrscr();
	gotoxy(30,12);
	cout << "Thank You For Playing!";
}

int main()
{
	do
	{
		short HighScore;
		HighScore = StartGame();
		short GunPosition = 1, Score = 0, TargetPosition;
		time_t TimeStart, TimeNow;
		char Key;
		randomize();
		TargetPosition = TargetChooser();
		gotoxy(1,24);
		textcolor(BLUE);
		cprintf("Score: ");
		cout << Score;
		DisplayGun(GunPosition);
		TimeStart = time(NULL);
		do //60 Second Timer Loop
		{
			Key = 'Y';
			if (kbhit())
			{
				Key = getch();
				if (Key == 0)
					Key = getch();
				switch(Key)
				{
					case 72: //If press up, move gun up
							if (GunPosition > 1)
							{
								EraseGun(GunPosition);
								GunPosition--;
								DisplayGun(GunPosition);
							}
							break;
					case 80: //If press down, move gun down
							if (GunPosition < 23)
							{
								EraseGun(GunPosition);
								GunPosition++;
								DisplayGun(GunPosition);
							}
							break;
					case 32: //If press space, fire, adjust score, + test target
							Explosion(GunPosition);
							Score = Scorer(Score, GunPosition, TargetPosition);
							if(GunPosition == TargetPosition)
								TargetPosition = TargetChooser();
							break;
					case 'b': //If press b shoot the laser sight
							DisplaySight(GunPosition, TargetPosition);
							break;
				}//switch
			}// if kbhit
			TimeNow = time(NULL);
			Timer(TimeNow, TimeStart);
		}while (60 - (TimeNow - TimeStart) > 0 && Key!='q'); //end timer
		EndGame(Score, HighScore);
	}while (PlayAgain() == 1);
	ThankYou();
	return 0;
}
